#include <stdio.h>
#include <string.h>

#define MAXLEN 256

int main(int argc, char *argv[]) {
    char line[MAXLEN];
    char *cmdname = argv[0];	/* Kommando-Name */
    char *s;
    int lineno = 0;		/* Zeilennummer in der Eingabe */
    int opt_v = 0;		/* Option -v gesetzt? */
    int opt_n = 0;		/* Option -n gesetzt? */

	/* Optionen verarbeiten */
    while (--argc > 0 && (*++argv)[0] == '-') {
	/* nach "--" kommen keine Optionen mehr (per Definition) */
	if ((*argv)[1] == '-' && (*argv)[2] == '\0') {
	    argc--; argv++; break;
	}
	/* steht nur "-", dann fehlt etwas ;-) */
	if ((*argv)[1] == '\0') {
	    fprintf(stderr, "%s: empty option\n", cmdname);
	    return 1;
	}
	for (s = *argv + 1; *s != '\0'; s++)
	    switch (*s) {	/* jede einzelne Option abarbeiten ... */
		case 'v' : opt_v = 1; break;
		case 'n' : opt_n = 1; break;
		default:	/* unbekannte Option! */
		    fprintf(stderr, "%s: illegal option '%c'\n", cmdname, *s);
		    return 2;
	    }
    }

    if (argc != 1) {	/* argc und argv wurden veraendert! */
	fprintf(stderr, "Usage: %s [-nv] pattern\n", cmdname);
	return 3;
    }

    while (fgets(line, MAXLEN, stdin)) {
	    /* das Resultat von strstr(), ein Zeiger,
	     * wird mittels ! in 0 bzw. 1 umgewandelt => Vergleich erst dann mgl. */
	if (!strstr(line, argv[0]) == opt_v) {
	    if (opt_n)
		printf("%d: ", lineno);
	    fputs(line, stdout);
	}
	lineno++;
    }
    return 0;
}
